package aimas2014.search.instantiations;

import massim.javaagents.agents.MarsUtil;
import aimas2014.search.MarsSearchNode;
import aimas2014.search.SearchNodeType;
import aimas2014.search.actions.ActionType.InstantiatedAction;
import eis.iilang.Action;

public final class InstantiatedRechargeAction extends InstantiatedAction {
    @Override
    public Action realize() {
        return MarsUtil.rechargeAction();
    }

    @Override
    public SearchNodeType apply(SearchNodeType s) {
        return ((MarsSearchNode) s.copy()).step().recharged();
    }

    @Override
    public int hashCode() {
        return "recharge".hashCode();
    }
    
    @Override
    public boolean equals(Object obj) {
    	return obj instanceof InstantiatedRechargeAction;
    }

	@Override
	public boolean isApplicable(SearchNodeType s) {
		return true;
	}
}